<?php

defined('IN_MET') or exit('No permission');

load::sys_func('file');

class build {

    public $dir = PATH_OWN_FILE.'install';

    public $skips = ['config','upload','templates','admin/update','app/system/pay','case'];
    public $skip_ext = false;

    public $file_type = ['js','php','css'];

    public $files = [];

    public $install_dir = ['index.php','about','admin','app/system','app/app/met_sms','app/app/met_template_s','app/app/ueditor','case','download','feedback','img','include','job','member','message','news','product','public','search','sitemap','templates/metv6','upload','install','config','admin/databack','online'];

    public $install_files = ['favicon.ico','robots.txt','6.0.0版功能及说明.txt','最终用户授权许可协议.txt','index.php','app/app/entrance.php'];

    public $update_file_path = PATH_OWN_FILE.'update/cms/new/file/v6.0.0/file/';

    public $old_version = '5.3.19';

    public $version = '6.0.0';


    public function __construct()
    {
        global $_M;
        $this->check=load::own_class('check','new');
    }

    public function get_language()
    {
        global $_M;
        $query = "SELECT * FROM {$_M['table']['language']} WHERE lang = 'cn'";
        $lang_cn = DB::get_all($query);

        $json_cn = array();

        foreach ($lang_cn as $v) {
            $json_cn[$v['name']] = $v;
        }
        file_put_contents(PATH_OWN_FILE.'json/v6.0.0lang_cn.json', json_encode($json_cn,JSON_UNESCAPED_UNICODE|JSON_PRETTY_PRINT));

        $query = "SELECT * FROM {$_M['table']['language']} WHERE lang = 'en'";
        $lang_en = DB::get_all($query);

        foreach ($lang_en as $v) {
            $json_en[$v['name']] = $v;
        }
        file_put_contents(PATH_OWN_FILE.'json/v6.0.0lang_en.json', json_encode($json_en,JSON_UNESCAPED_UNICODE|JSON_PRETTY_PRINT));
    }

    public function get_install(){
        global $_M;

        deldir(PATH_OWN_FILE.'install',1);

        $files = array();
        foreach ($this->install_dir as $dir) {
           foreach (traversal(PATH_WEB.$dir) as $file) {
               copyfile(PATH_WEB.$file,PATH_OWN_FILE.'install/'.$file);
           }
        }

        foreach ($this->install_files as $file) {
            if(stristr(PHP_OS,"WIN"))$file=@iconv("utf-8","gbk",$file);
            copyfile(PATH_WEB.$file,PATH_OWN_FILE.'install/'.$file);
        }

        $admin_update = PATH_OWN_FILE.'install/admin/update';

        if(!file_exists($admin_update)){
            mkdir($admin_update,0777,true);
        }else{
            deldir($admin_update,1);
        }

        $admin_databack = PATH_OWN_FILE.'install/admin/databack';

        if(!file_exists($admin_databack)){
            mkdir($admin_databack,0777,true);
        }else{
            deldir($admin_databack,1);
        }

        $upload_thumb_src = PATH_OWN_FILE.'install/upload/thumb_src';
        if(!file_exists($upload_thumb_src)){
            mkdir($upload_thumb_src,0777,true);
        }else{
            deldir($upload_thumb_src,1);
        }

        if(!file_exists(PATH_OWN_FILE.'install/upload/file')){
            mkdir(PATH_OWN_FILE.'install/upload/file',0777,true);
        }
        unlink(PATH_OWN_FILE.'install/config/install.lock');
        mkdir(PATH_OWN_FILE.'install/cache');
        rename(PATH_OWN_FILE.'install/app/app/met_template_s', PATH_OWN_FILE.'install/app/app/met_template');
        $this->save_files_json();
        $this->save_fields_json();
    }


    public function get_update()
    {
        global $_M;


        if(!file_exists($this->update_file_path)){
            mkdir($this->update_file_path,0777,true);
        }
        deldir($this->update_file_path,1);
        $this->skip_ext = true;
        $this->listFiles($this->dir);

        $files = $this->fileHash($this->files);
        $updates = array();
        $updates[] = "file/v{$this->version}/install.class.php";
        foreach ($files as $file => $hash) {
            if(file_exists(PATH_OWN_FILE.$this->old_version.'/'.$file)){

                // 如果这个文件被修改了,也是更新文件
                $old_hash = md5_file(PATH_OWN_FILE.$this->old_version.'/'.$file);
                if($old_hash != $hash){
                    $updates[] = "file/v{$this->version}/file/".$file;
                    copyfile($this->dir.'/'.$file,$this->update_file_path.$file);
                }
            }else{
                $updates[] = "file/v{$this->version}/file/".$file;
                copyfile($this->dir.'/'.$file,$this->update_file_path.$file);
                // 如果5.3.19不存在这个文件，那就是更新文件
            }
        }

        $this->saveList($updates);

        return $updates;
    }


    public function get_config()
    {
        global $_M;
        $query = "SELECT * FROM `met_config` where lang = 'cn' or lang = 'metinfo'";
        $config =  DB::get_all($query);
        $configs = array();
        foreach ($config as $c) {
            if($c['name'] != 'met_adminfile' && $c['name'] != 'met_secret_key'){
                $configs[$c['name']][$c['columnid']] = $c;
            }

        }
        file_put_contents(PATH_OWN_FILE.'json/v6.0.0config.json', json_encode($configs,JSON_UNESCAPED_UNICODE|JSON_PRETTY_PRINT));
    }

    public function saveList($files)
    {
        $dllist = "<?php\n\$dllist = ";
        array_unshift($files, 'file/v'.$this->version.'/dllist.php');

        $dllist .= var_export($files,true);
        $dllist .=";\n\n";

        $dllist .= "if(file_exists(PATH_WEB.'install/')){\n";

        $dir = $this->update_file_path.'install';
        $install = traversal($dir);

        foreach ($install as $file) {
            $new_file = str_replace(str_replace(PATH_WEB, '', $this->update_file_path), "file/v{$this->version}/file/", $file);
            $dllist .= '$dllist[]='."'".$new_file."';\n";
        }

        $dllist .="};\n\n?>";
        file_put_contents($this->update_file_path.'../dllist.php', $dllist);
    }

    public function save_files_json()
    {
        global $_M;

        $this->listFiles($this->dir);
        $files = $this->fileHash($this->files);
        file_put_contents(PATH_OWN_FILE.'json/v6.0.0.json', json_encode($files,JSON_UNESCAPED_UNICODE|JSON_PRETTY_PRINT));
    }

    // 生成字段json
    public function save_fields_json()
    {
        global $_M;
        $json = array();
        $res = $this->check->list_tables();
        foreach ($res as $table) {
            $fields = $this->check->list_fields($table);
            $json[$table]= $fields;
        }

        file_put_contents(PATH_OWN_FILE.'json/v6.0.0mysql.json', json_encode($json,JSON_PRETTY_PRINT|JSON_UNESCAPED_UNICODE));
    }




    public function listFiles($dir)
    {
        $files = array();

         $handle = opendir($dir);
         while(($file = readdir($handle))!==false){

            if($file != '.' && $file != '..'){
                $path = $dir.'/'.$file;
                if(is_dir($path)){
                    if($this->check_skip($path)){
                        self::listFiles($path);
                    }

                }else{
                    if(stristr(PHP_OS,"WIN"))$path=@iconv("utf-8","gbk",$path);
                    if($this->check_ext($path)){
                        $this->files[] = $path;
                    }
                }

            }
        }
        return $files;
    }


    /**
     * 要跳过的文件夹
     */
    public function check_skip($path)
    {
        foreach ($this->skips as $skip) {

            if(strpos($path, PATH_OWN_FILE.'install/'.$skip) !== false){
                return false;
            }
        }

        return true;
    }

    /**
     * 指定的文件后缀
     */
    public function check_ext($file)
    {
        if($this->skip_ext){
            return true;
        }
        $info = pathinfo($file);
        foreach ($this->file_type as $ext) {
            if(isset($info['extension'])){
                if($ext == $info['extension']){
                    return true;
                }
            }
        }

        return false;
    }

    /**
     * 文件散列列表
     * @DateTime 2018-03-02
     * @return  file=>hash
     */
    public function fileHash($files)
    {

        $hashs = [];
        foreach ($files as $file) {
            $name = str_replace($this->dir.'/', '', $file);

            $hashs[$name] = md5_file($file);
        }

        return $hashs;
    }


}