<?php

defined('IN_MET') or exit('No permission');

load::sys_func('file');

class check {


    public function list_dirs()
    {
        global $_M;

        $dirs = array(
            $_M['config']['met_adminfile']=>'后台更新和备份',
            $_M['config']['met_adminfile'].'/update'=>'应用商店下载、升级、安装应用和模板',
            $_M['config']['met_adminfile'].'/databack'=>'网站和数据库备份',
            'cache'=>'系统缓存目录',
            'upload'=>'上传图片目录',
            'templates'=>'模板目录',
            'upload/thumb_src'=>'生成缩略图',
            'upload/file'=>'上传文件目录'
        );
        $html = "";
        foreach ($dirs as $dir => $msg) {
            if(!file_exists(PATH_WEB.$dir)){
                $html .= "<p><span style='margin-right: 50px;'>目录不存在 </span> <span>{$dir}</span> <span style='float:right'>{$msg}</span> </p>";
            }else{
                if(!is_writable(PATH_WEB.$dir)){
                    $html .= "<p><span style='margin-right: 50px;'> 目录不可写 </span> <span>{$dir}</span> <span style='float:right'>{$msg}</span> </p>";
                }
            }
        }

        return $html;
    }
    /**
     * 基于系统指纹最新的丢失文件和被修改过的文件
     * @DateTime 2018-02-24
     * @return string
     */
    public function list_files()
    {
        global $_M;
        $files = $this->check_hash();
        $html = '';
        foreach ($files as $file) {
            if(strstr($file, '###')){
                $file = str_replace('###', '', $file);
                $html .= "<p><span style='margin-right: 118px;'>[文件不存在]</span> <span >{$file}</span> <a href='javascript:;' style='float:right;' class='download_file' data-file=\"{$file}\">重新下载</a></p>";
            }else{
                $mtime = date('Y-m-d H:i:s',filemtime(PATH_WEB.$this->switch_admin($file)));
                $html .= "<p><span style='margin-right: 50px;'>[{$mtime}]</span> <span>{$file}</span> <a href='javascript:;' style='float:right;' class='download_file' data-file=\"{$file}\">重新下载</a></p>";
            }
        }

        return $html;
    }


    /**
     * 基于指纹的数据表字段丢失
     * @DateTime 2018-02-24
     * @return  string
     */
    public function list_diffs()
    {
        global $_M;

        $diff = $this->check_mysql();

        $html = '';
        foreach ($diff as $table => $field) {
            $html.="<p><span style='margin-right: 200px;'>{$table}</span>";
            foreach ($field as $f => $t) {
                $html.= "<span >{$f} , </span>";
            }
            $html.= "<a href='javascript:;' style='float:right;' class='alter_field' data-table=\"{$table}\">修复</a></p>";
        }
        return $html;
    }


    public function list_config()
    {
        global $_M;
        if($_M['lang'] != 'cn'){
            return;
        }
        $string = $this->app_get("https://www.metinfo.cn/upload/json/v{$_M['config']['metcms_v']}config.json");

        file_put_contents(PATH_OWN_FILE."v{$_M['config']['metcms_v']}config.json", $string);
        $config_data = json_decode($string,true);


        $query = "SELECT name,value,columnid FROM {$_M['table']['config']} WHERE lang = 'cn' OR lang = 'metinfo'";
        $configs = DB::get_all($query);


        $local_config = array();
        foreach ($configs as $config) {
            $local_config[$config['name']][$config['columnid']] = $config['value'];
        }


        $html = "";
        foreach ($config_data as $c) {
            foreach ($c as $cid => $v) {
                if(!isset($local_config[$v['name']])){
                    $html .= "<p><span style='margin-right: 50px;'>不存在 {$v['name']} </span> <span>默认值为 {$v['value']}</span> <span style='float:right'><a href='javascript:;' data-name=\"{$v['name']}\" data-config_lang=\"{$v['lang']}\" data-columnid = \"{$cid}\" class='add_config'>修复</a></span> </p>";
                }else{

                    if(($v['value'] || is_numeric($v['value'])) && !$local_config[$v['name']][$cid] && !is_numeric($local_config[$v['name']][$cid])){
                        $html .= "<p><span style='margin-right: 50px;'>没有值 {$v['name']}</span> <span> 默认值为 {$v['value']}</span> <span style='float:right'><a href='javascript:;' data-name=\"{$v['name']}\" data-config_lang=\"{$v['lang']}\" data-columnid = \"{$cid}\" class='add_config'>修复</a></span> </p>";
                    }
                }
            }

        }
        return $html;
    }

    /**
     * 官网最新文件指纹和本地文件对比
     * @DateTime 2018-02-24
     * @return array 丢失的和被修改过的系统文件
     */
    public function check_hash()
    {
        global $_M;
        $string = $this->app_get("https://www.metinfo.cn/upload/json/v{$_M['config']['metcms_v']}.json");
        $files = json_decode($string,true);

        $hashs = array();
        foreach ($files as $file => $hash) {
            $fileName = $this->switch_admin($file);
            if(file_exists(PATH_WEB.$fileName)){
                $new_hash = md5_file(PATH_WEB.$fileName);
                if($new_hash != $hash){
                    $hashs[] = $file;
                }
            }else{
                $hashs[] = '###'.$file;
            }
        }

        return $hashs;
    }

    /**
     * 重新下载最新的系统文件
     * @DateTime 2018-02-24
     * @param   系统文件名
     * @return  array
     */
    public function download($file)
    {
        global $_M;

        $file_string = $this->app_get("https://app.metinfo.cn/index.php?lang=cn&n=platform&c=dl&a=dorecovery&file={$file}&version=v{$_M['config']['metcms_v']}");

        $file_path = dirname(PATH_WEB.$this->switch_admin($file));

        if(!file_exists($file_path)){
            $mk = mkdir($file_path,0777,true);
            if(!$mk){
                return array('status'=>1,'msg'=>'创建文件目录失败');
            }
        }

        if(!$file_string){
            return array('status'=>0,'msg'=>PATH_WEB.$file.'获取失败');
        }
        $write = file_put_contents(PATH_WEB.$this->switch_admin($file), base64_decode($file_string));
        if($write){
            return array('status'=>1,'msg'=>'下载成功');
        }else{
            return array('status'=>0,'msg'=>PATH_WEB.$file.'文件写入失败');
        }

    }

    /**
     * 修复系统缺失的字段
     * @DateTime 2018-02-24
     * @param  表名
     * @return  array
     */
    public function alter($table)
    {
        global $_M;
        $diff = $this->check_mysql();
        foreach ($diff[$table] as $field => $type) {
            $query = "ALTER TABLE `{$table}` ADD COLUMN `{$field}`  {$type}";
            $row = DB::query($query);
            if(!$row){
                return array('status'=>0,'msg'=>'修复失败 '.DB::error());
            }
        }

        return array('status'=>1,'msg'=>'修复成功');
    }

    public function add_lang($data)
    {
        global $_M;
        if(!is_array($data)){
            return array('status'=>1,'msg'=>'数据错误');
        }

        $sql = $this->get_sql($data);
        $query = "INSERT INTO {$_M['table']['language']} SET {$sql}";

        $add = DB::query($query);
        if($add){
            return array('status'=>1,'msg'=>'修复成功');
        }else{
             return array('status'=>0,'msg'=>'修复失败 '.DB::error());
        }
    }


    public function add_config($data)
    {
        global $_M;
        if(!is_array($data)){
            return array('status'=>1,'msg'=>'数据错误');
        }

        $sql = $this->get_sql($data);
        $query = "SELECT id FROM {$_M['table']['config']} WHERE name = '{$data['name']}' AND lang = '{$data['lang']}' AND columnid = '{$data['columnid']}'";
        $has = DB::get_one($query);
        if($has){
            $query = "UPDATE {$_M['table']['config']} SET value='{$data['value']}' WHERE id = {$has['id']}";
            $update = DB::query($query);
            if(!$update){
                return array('status'=>0,'msg'=>'更新失败 '.DB::error());
            }
        }else{
            $query = "INSERT INTO {$_M['table']['config']} SET {$sql}";
            $add = DB::query($query);
             if(!$add){
                return array('status'=>0,'msg'=>'插入失败 '.DB::error());
            }
        }

        return array('status'=>1,'msg'=>'修复成功');
    }

    /**
     * 对比出系统丢失的字段
     * @DateTime 2018-02-24
     * @return  array 差异表和字段
     */
    public function check_mysql()
    {
        global $_M;
        $string = $this->app_get("https://www.metinfo.cn/upload/json/v{$_M['config']['metcms_v']}mysql.json");
        $sys_data = json_decode($string,true);
        $tables = $this->list_tables();
        $sys_tables = array();


        $info = array();
        foreach ($sys_data as $table => $field) {
            $sys_table = str_replace('met_', $_M['config']['tablepre'], $table);
            $sys_tables[] = $sys_table;

            $fields = $this->list_fields($sys_table);
            $diff_field = array_diff_key($field, $fields);
            if($diff_field){
                $info[$sys_table] = $diff_field;
            }
        }
        return $info;
    }

    public function check_lang()
    {
        global $_M;
        $string = $this->app_get("https://www.metinfo.cn/upload/json/v{$_M['config']['metcms_v']}lang_{$_M['lang']}.json");

        file_put_contents(PATH_OWN_FILE."v{$_M['config']['metcms_v']}lang_{$_M['lang']}.json", $string);
        $lang_data = json_decode($string,true);


        $query = "SELECT name,value FROM {$_M['table']['language']} WHERE lang = '{$_M['lang']}'";
        $langs = DB::get_all($query);

        $local_lang = array();
        foreach ($langs as $v) {
            $local_lang[$v['name']] = $v['value'];
        }

        $diff_lang = array_diff_key($lang_data, $local_lang);
        $html = "";
        if($diff_lang){
            foreach ($diff_lang as $d) {
                if($d['name'] != 'unitytxt_8'){
                 $html .= "<p><span style='margin-right: 50px;'> {$d['name']} </span> <span>{$d['value']}</span> <span style='float:right'><a href='javascript:;' data-name=\"{$d['name']}\" class='add_lang'>修复</a></span> </p>";
                }
            }
        }

        return $html;
    }


    public function list_tables() {
        global $_M;
        $query = "SHOW TABLE status";
        $tables = array();
        foreach (DB::get_all($query) as $key => $v) {
            $tables[] = $v['Name'];
        }
        return $tables;
    }


    public function list_fields($table) {
        global $_M;
        $query = "SHOW FULL FIELDS FROM {$table}";
        $fields = DB::get_all($query);
        $data = array();
        foreach ($fields as $key => $v) {
            $data[$v['Field']] = $v['Type'];
        }
        return $data;
    }


    public function check_ini() {
        global $_M;
        $ini = array();
        $ini['upload_tmp_dir'] = ini_get('upload_tmp_dir');
        $ini['curl'] = function_exists('curl_init') ? '支持' : '<mark>不支持</mark>';
        $ini['upload_max_filesize'] =  ini_get('upload_max_filesize');
        $ini['total'] = $this->get_size(@disk_total_space("."));
        $ini['valid'] = $this->get_size(@disk_free_space("."));
         $ini['pcre'] = extension_loaded('pcre') && @preg_match('/pcre/u', 'pcre') ? '支持' : '<mark>不支持</mark>';
        $ini['thumb'] = '支持';
        if(!is_writable(PATH_WEB.'upload/thumb_src') || !file_exists(PATH_WEB.'upload/thumb_src')){
            $ini['thumb'] = '<mark>'.PATH_WEB.'upload/thumb_src'.'不可写或不存在</mark>';
        }
        if(!function_exists('gd_info')){
            $ini['thumb'] = '<mark>不支持</mark>';
        }

        $query = "SELECT * FROM {$_M['table']['applist']} WHERE no = 50002";
        $has = DB::get_one($query);
        if(!$has){
            $time = time();
            $query = "INSERT INTO `{$_M['table']['applist']}` SET
                    `id`        =  '',
                    `no`        =  '50002',
                    `ver`       =  '1.0',
                    `m_name`    =  'met_template',
                    `m_class`   =  'temtool',
                    `m_action`  =  'dotemlist',
                    `appname`   =  '官方模板管理工具',
                    `info`      =  '官方商业模板请在此进行管理操作',
                    `display`   =  2,
                    `addtime`   =  {$time},
                    `updatetime`=  {$time}";
            DB::query($query);
        }
        return $ini;
    }


    public function switch_admin($file)
    {
        global $_M;
        $info = explode('/', $file);
        $full_file = PATH_WEB.$file;
        if($info[0] == 'admin'){
            $fileName = str_replace(PATH_WEB.'admin', PATH_WEB.$_M['config']['met_adminfile'], $full_file);
            $fileName = str_replace(PATH_WEB, '', $fileName);

        }else{
            $fileName = $file;
        }

        return $fileName;
    }

    public function get_sql($data) {
        global $_M;

        $sql = "";
        foreach ($data as $key => $value) {
            $value = str_replace("'", "\'", $value);
            $sql .= " {$key} = '{$value}',";
        }
        return trim($sql,',');
    }

    public function app_get($url)
    {
        global $_M;
        $json =  file_get_contents($url);
        if(!$json){
            $json = $this->curl($url);
        }
        return $json;
    }

     public function get_size($size, $decimals = 2)
    {
        switch (true) {
            case $size >= pow(1024, 3):
                return round($size / pow(1024, 3), $decimals) . " GB";
            case $size >= pow(1024, 2):
                return round($size / pow(1024, 2), $decimals) . " MB";
            case $size >= pow(1024, 1):
                return round($size / pow(1024, 1), $decimals) . " KB";
            default:
                return $size . 'B';
        }
    }

    public function curl($url) {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_POST, 0);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_TIMEOUT, 8);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
        $result = curl_exec($ch);
        curl_close($ch);
        return $result;
    }
}