<?php
defined('IN_MET') or exit('No permission');

class LW_REPLY
{
    public function __construct()
    {
        global $_M;
        $this->LW_BASE = load::own_class('LW_BASE', 'new');
        load::own_class('../met_wechat/include/class/LW');
        $this->config = LW::config('get', '', 'met_wechat', 'metinfo');
    }
    /**
     * 校验是否是微信正确post！！
     */
    public function checkSign()
    {
        $signature = $_GET["signature"];
        $timestamp = $_GET["timestamp"];
        $nonce     = $_GET["nonce"];
        $token     = $this->config['wechat_token'];
        $signkey   = array($token, $timestamp, $nonce);

        sort($signkey, SORT_STRING);
        $signString = implode($signkey);
        $signString = sha1($signString);

        if ($signString == $signature) {
            echo $_GET["echostr"];
        } else {
            echo '';
        }
    }
    public function reply($postStr)
    {
        global $_M;
        //xml转array
        libxml_disable_entity_loader(true);
        $post_data = json_decode(json_encode(simplexml_load_string($postStr, 'SimpleXMLElement', LIBXML_NOCDATA)), true);
        //消息排重
        $openid      = $post_data['FromUserName'];
        $usetime     = $post_data['CreateTime'];
        $this->msgid = PATH_APP_FILE . "cache/" . md5($openid . $post_data['CreateTime'] . $post_data['MsgId']);
        if (is_file($this->msgid)) {
            echo "success";
            die;
        } else {
            file_put_contents($this->msgid, "1");
        }
        switch ($post_data['MsgType']) {
            case 'event':
                switch ($post_data['Event']) {
                    case 'subscribe':
                        //关注微信
                        if ($this->config['auto_reply_gz']) {
                            $this->post_reply($this->config['auto_reply_gz'], $openid);
                        }
                        $userinfo = $this->LW_BASE->get_userinfo_sub($openid);
                        if ($this->config['backurl_gz']) {
                            $this->post_url($this->config['backurl_gz'], $post_data);
                        }
                        break;
                    case 'unsubscribe':
                        //取消关注
                        LW::sql_update("nwechat_user", array("subscribe" => 0), "openid = '{$openid}'");
                        unlink($this->msgid);
                        break;
                    case 'LOCATION':
                        //更新地理位置
                        $this->update_user_location($post_data);
                        unlink($this->msgid);
                        break;
                    case 'CLICK':
                        //点击菜单关键词
                        $this->post_keyword(trim($post_data['EventKey']), $post_data);
                        break;
                    case 'VIEW':
                        unlink($this->msgid);
                        break;
                }
                break;
            case 'text':
                //文字内容
                $this->post_keyword(trim($post_data['Content']), $post_data);
                break;
            case 'voice':
                //语音转文字处理
                if ($post_data['Recognition']) {
                    $this->post_keyword(str_replace(array("。", "？", "！"), "", trim($post_data['Recognition'])), $post_data);
                }
                break;
            case 'location':
                //推送用户位置信息
                //暂时无操作
                break;
        }
        $this->LW_BASE->save_usetime($usetime, $openid);
    }
    /**
     * 处理关键词数据
     */
    public function post_keyword($keyword, $post_data)
    {
        global $_M;
        $keyword = explode("#", $keyword);
        $keyword = $keyword[0];
        $list    = LW::sql_get_all("nwechat_keywords", "word LIKE '%{$keyword}%'", "level DESC,id DESC");
        if ($list) {
            //如果有关键词
            foreach ($list as $key => $val) {
                $words = explode("|", $val['word']);
                if ($val['type'] == '1') {
                    //精确匹配关键词
                    foreach ($words as $key => $val2) {
                        if ($val2 && $val2 == $keyword) {
                            $replyid = $val['m_name'] ? $this->post_app($val, $post_data) : $val['replyid'];
                            break;
                        }
                    }
                    break;
                } elseif ($val['type'] == '2') {
                    //模糊匹配关键词
                    $replyid = $val['m_name'] ? $this->post_app($val, $post_data) : $val['replyid'];
                    break;
                }
            }
        } else {
            //如果没有关键词
            $no_word = LW::sql_get_all("nwechat_keywords", "type = 3 AND is_own = 1", "level DESC, id DESC");
            if ($no_word) {
                //如果有应用接收无匹配内容，推送给应用
                foreach ($no_word as $key => $val) {
                    $this->post_app($val, $post_data);
                    break;
                }
            } else {
                //没有任何关键词匹配，使用自带无关键词返回内容
                $replyid = $this->config['auto_reply_no'];
            }
        }
        if ($replyid) {
            $this->post_reply($replyid, $post_data['FromUserName']);
        }
    }
    /**
     * 批量发送给用户
     */
    public function post_reply($replyid, $openid)
    {
        global $_M;
        $replyid = explode("|", $replyid);
        foreach ($replyid as $key => $val) {
            if ($val) {
                $this->reply_self($val, $openid);
            }
        }
    }
    /**
     * 把关键词post给应用
     */
    public function post_app($app_data, $post_data)
    {
        global $_M;
        $url = $this->LW_BASE->self_url($app_data['m_name'], $app_data['m_class'], $app_data['m_action']) . $app_data['own_url'];
        $key = "&timestamp=" . $_GET['timestamp'] . "&nonce=" . $_GET['nonce'] . "&signature=" . $_GET['signature'];
        $r   = $this->LW_BASE->curl_post_json($url . $key, json_encode($post_data), 3, 1);
        $r   = $r ? $r : '';
        echo $r;
    }
    /**
     * 把关键词post给应用
     */
    public function post_url($url, $post_data)
    {
        global $_M;
        $url = explode("|", $url);
        foreach ($url as $key => $val) {
            if ($val) {
                $this->LW_BASE->curl_post_json($val, json_encode($post_data));
            }
        }
    }
    /**
     * 处理自带回复内容
     */
    public function reply_self($id, $openid)
    {
        global $_M;
        $reply = LW::sql_get_one("nwechat_reply", "id = {$id}");
        if ($reply) {
            $r           = array();
            $r['touser'] = $openid;
            switch ($reply['type']) {
                case 'text':
                    $r['msgtype']         = "text";
                    $r['text']['content'] = str_replace("\r\n", "\n", urldecode($reply['text']));
                    break;
                case 'image':
                    $r['msgtype']           = "image";
                    $r['image']['media_id'] = $reply['mediaid'];
                    break;
                case 'voice':
                    $r['msgtype']           = "voice";
                    $r['voice']['media_id'] = $reply['mediaid'];
                    break;
                case 'news':
                    $r['msgtype']          = "news";
                    $r['news']['articles'] = $this->get_wechat_news($reply['msg_list']);
                    break;
                case 'column':
                    $r['msgtype']          = "news";
                    $r['news']['articles'] = $this->get_met_columns($reply['columns']);
                    break;
            }
            $this->LW_BASE->send_custom(LW::json_encode($r));
        }
        unlink($this->msgid);
    }
    /**
     * 处理自带图文消息数组
     */
    public function get_wechat_news($id)
    {
        global $_M;
        $id   = implode(",", array_filter(explode("|", $id)));
        $news = LW::sql_get_all("nwechat_news", "id IN ({$id})", "FIELD (id,{$id})");
        $i    = 0;
        foreach ($news as $key => $val) {
            $r[$i]['title']       = $val['title'];
            $r[$i]['description'] = substr($val['description'], 0, 300);
            $r[$i]['url']         = $val['link'] ? $val['link'] : $this->LW_BASE->self_url('met_wechat', 'met_wechat', 'domsg_tmp') . '&action=detail&id=' . $val['id'];
            $r[$i]['picurl']      = $_M['url']['site'] . str_replace("../", "", $val['img']);
            $i++;
            if ($i > 7) {break;}
        }
        return $r;
    }
    /**
     * 处理网站栏目文章数组
     */
    public function get_met_columns($columns)
    {
        global $_M;
        $columns = explode("-", $columns);
        switch ($columns[0]) {
            case '3':
                $filename = 'product';
                break;
            case '4':
                $filename = 'download';
                break;
            case '5':
                $filename = 'img';
                break;
            default:
                $filename = 'news';
                break;
        }
        $columns[2] = !empty($columns[2]) && !ctype_space($columns[2]) ? " AND class2 = " . $columns[2] : '';
        $columns[3] = !empty($columns[3]) && !ctype_space($columns[3]) ? " AND class3 = " . $columns[3] : '';
        $com_ok     = $columns[4] == '1' ? " AND com_ok = 1" : '';
        $news       = LW::sql_get_all($filename, "class1 = {$columns[1]}{$columns[2]}{$columns[3]}{$com_ok}", "no_order,id DESC", $columns[5]);
        $foldername = LW::sql_get_one("column", "id = {$columns[1]}");
        $i          = 0;
        foreach ($news as $key => $val) {
            $url                  = $val['link'] ? $val['link'] : $_M['url']['site'] . $foldername['foldername'] . '/show' . $filename . '.php?lang=' . $val['lang'] . '&id=' . $val['id'];
            $picurl               = $val['imgurl'] ? $_M['url']['site'] . str_replace("../", "", $val['imgurl']) : "";
            $r[$i]['title']       = iconv("UTF-8", "UTF-8//IGNORE", $val['title']);
            $r[$i]['description'] = iconv("UTF-8", "UTF-8//IGNORE", substr($val['description'], 0, 300));
            $r[$i]['url']         = iconv("UTF-8", "UTF-8//IGNORE", $url);
            $r[$i]['picurl']      = iconv("UTF-8", "UTF-8//IGNORE", $picurl);
            $i++;
            if ($i > 7) {break;}
        }
        return $r;
    }
    /**
     * 更新用户地理位置
     */
    public function update_user_location($post_data)
    {
        global $_M;
        $data = json_encode($post_data);
        LW::sql_update("nwechat_user", array("location" => $data), "openid = '{$post_data[FromUserName]}'");
    }
}
