<?php
# MetInfo Enterprise Content Management System 
# Copyright (C) MetInfo Co.,Ltd (http://www.metinfo.cn). All rights reserved. 
defined('IN_MET') or exit('No permission');
load::mod_class('pay/web/pay');
class alipay extends pay {
    public $apiconfig;
    public function __construct() {
        global $_M;
        parent::__construct();
        $this->alipay_config['partner']       = $this->GetAPI('3', 'app_partner');
        $this->alipay_config['seller_email']  = $this->GetAPI('3', 'app_seller_email');
        $this->alipay_config['key']           = $this->GetAPI('3', 'app_key');
        $this->alipay_config['sign_type']     = strtoupper('MD5');
        $this->alipay_config['input_charset'] = strtolower('utf-8');
        $this->alipay_config['cacert']        = PATH_WEB.str_replace("/","\\",substr($this->GetAPI('3', 'app_cacert'),3));
        $this->alipay_config['transport']     = 'http';
    }
    /**
     * 支付宝支付   
     * @param String(64)   out_trade_no      商户网站唯一订单号（支付宝合作商户网站唯一订单号）
     * @param String(256)  subject           商品名称（商品的标题/交易标题/订单标题/订单关键字等，该参数最长为128个汉字）
     * @param String(4)    payment_type      支付类型，默认值为：1（商品购买）——1|商品购买、2|捐赠、3|电子卡券
     * @param Number       total_fee         交易金额（该笔订单的资金总额，单位为RMB-Yuan。取值范围为[0.01，100000000.00]，精确到小数点后两位）    
     * @param String(190)  notify_url        服务器异步通知页面路径,支付宝服务器主动通知商户网站里指定的页面http路径。
     * @param String(200)  return_url        页面跳转同步通知页面路径,支付宝处理完请求后，当前页面自动跳转到商户网站里指定页面的http路径。
     * @param String(1000) body              商品描述,对一笔交易的具体描述信息。如果是多种商品，请将商品描述字符串累加传给body。
     * @param String(400)  show_url          商品展示网址,收银台页面上，商品展示的超链接。
     * @param String       anti_phishing_key 防钓鱼时间戳,通过时间戳查询接口获取的加密支付宝系统时间戳.如果已申请开通防钓鱼时间戳验证，则此字段必填。
     * @param String(15)   exter_invoke_ip   客户端IP,用户在创建交易时，该用户当前所使用机器的IP。如果商户申请后台开通防钓鱼IP地址检查选项，此字段必填，校验用。
     */
    public function alipay($date) {
        global $_M;
        require_once("alipay/alipay_submit.class.php");
        
        $payment_type      = "1";
        $notify_url        = is_strinclude($_M['url']['pay_notify'], 'localhost')?'':$_M['url']['pay_notify'];
        $return_url        = is_strinclude($_M['url']['pay_return'], 'localhost')?'':$_M['url']['pay_return'];
        $anti_phishing_key = "";
        $exter_invoke_ip   = "";
        $out_trade_no      = $date["out_trade_no"];
        $subject           = $date["subject"];
        $total_fee         = $date["total_fee"];
        $body              = $date["body"];
        $show_url          = $date["show_url"];
        //构造要请求的参数数组，无需改动
        $parameter = array(
                        "service"       => "create_direct_pay_by_user",
                        "partner"       => trim($this->alipay_config['partner']),
                        "seller_email"  => trim($this->alipay_config['seller_email']),
                        "payment_type"	=> $payment_type,
                        "notify_url"	=> $notify_url,
                        "return_url"	=> $return_url,
                        "out_trade_no"	=> $out_trade_no,
                        "subject"	=> $subject,
                        "total_fee"	=> $total_fee,
                        "body"          => $body,
                        "show_url"	=> $show_url,
                        "anti_phishing_key" => $anti_phishing_key,
                        "exter_invoke_ip"   => $exter_invoke_ip,
                        "_input_charset"    => trim(strtolower($this->alipay_config['input_charset']))
        );
        //建立请求
        $alipaySubmit = new AlipaySubmit($this->alipay_config);
        $html_text    = $alipaySubmit->buildRequestForm($parameter,"get", "OK");
        echo $html_text;
    }
    
    /**
     * 支付宝异步通知验证
     */
    public function donotify() {
        require_once("alipay/alipay_notify.class.php");
        //计算得出通知验证结果
        $alipayNotify = new AlipayNotify($this->alipay_config);
        $verify_notify = $alipayNotify->verifyNotify();
        if($verify_notify) {
            return TRUE;
        } else {
            return FALSE;
        }
    }
    
    /**
     * 支付宝同步通知验证
     */
    public function doreturn() {
        require_once("alipay/alipay_notify.class.php");
        //计算得出通知验证结果
        $alipayNotify = new AlipayNotify($this->alipay_config);
        $verify_result = $alipayNotify->verifyReturn();
        if($verify_result) {
            return TRUE;
        } else {
            return FALSE;
        }
    }
}
# This program is an open source system, commercial use, please consciously to purchase commercial license.
# Copyright (C) MetInfo Co., Ltd. (http://www.metinfo.cn). All rights reserved.
?>