<?php
# MetInfo Enterprise Content Management System 
# Copyright (C) MetInfo Co.,Ltd (http://www.metinfo.cn). All rights reserved. 
defined('IN_MET') or exit('No permission');
load::mod_class('pay/pay');
class app extends pay {
    public function __construct() {
        global $_M;
        parent::__construct();
    }
    /**
     * @param Int         paytype        支付类型，1|微信扫码支付，2|财付通支付，3|支付宝支付，4|银联支付，5|PayPal支付，6|微信H5支付
     * @param String(128) body           商品描述（商品或支付单简要描述）
     * @param String(256) subject        商品名称（商品的标题/交易标题/订单标题/订单关键字等，该参数最长为128个汉字）
     * @param String(32)  out_trade_no   商户订单号（商户支付的订单号由商户自定义生成，长度不大于32位、可包含字母）
     * @param String(127) attach         附加数据（在查询API和支付通知中原样返回，该字段主要用于商户携带订单的自定义数据）
     * @param String(32)  goods_tag      商品标记（商品标记，代金券或立减优惠功能的参数）
     * @param String(32)  product_id     商品ID（trade_type=NATIVE，此参数必传。此id为二维码中包含的商品ID，商户自行定义）
     * @param Int         total_fee      总金额（订单总金额，原始单位为分，只能为整数。可后台处理为“元”为单位）
     * @param Int(11)     no             调用接口的应用编号（存在于applist）
     * 
     * 返回参数说明：
     * ①微信扫码支付     返回微信访问地址（weixin://*****）【JSON格式'code_url'】，需要通过qrcode.php转码
     * ②财付通支付       空返回（开发中）
     * ③支付宝支付       无数据返回，直接跳转支付宝网关
     * ④银联支付         无数据返回，直接跳转银联支付网关
     * ⑤PayPal          空返回（开发中）
     * ⑥微信客户端支付   以JSON形式返回微信客户端（H5支付）支付页面JS需要的两个参数（'Parameters','Address'），具体使用参考templates/met/jsapi.php文件
     */
    public function dointerface() {
        global $_M;
        //获取订单参数
		$date = load::mod_class('pay/include/class/interface_pay', 'new')->data_decode($_M['form']['strcode']);
		if(!$date){
			echo json_encode(array('error'=>'time_out'));
		}
		$date['pay_type']     = $_M['form']['paytype']?$_M['form']['paytype']:(empty($_GET["code"])?'':'6');
		/*
        $date['out_trade_no'] = $_M['form']['out_trade_no'];
        $date['pay_type']     = $_M['form']['paytype']?$_M['form']['paytype']:(empty($_GET["code"])?'':'6');
        $date['body']         = $_M['form']['body'];
        $date['subject']      = $_M['form']['subject'];
        $date['attach']       = $_M['form']['attach'];
        $date['goods_tag']    = $_M['form']['goods_tag'];
        $date['product_id']   = $_M['form']['product_id'];
        $date['total_fee']    = $_M['form']['total_fee'];
        $date['no']           = $_M['form']['no'];
        $date['return_url']   = $_M['form']['return_url'];
        */
        if($this->GetPayOpen() && $date['out_trade_no']) {
            $result = $this->OrderProcessing($date);
            echo $result;
        } else {
            echo json_encode(array('error'=>'invalid'));                                              //判断插件开关状态，关闭状态返回FALSE
        }
    }
    /**
     * 订单处理
     */
    public function OrderProcessing($date){
        $Order = $this->GetOeder($date['out_trade_no']);
        if(!$Order) {
            $result = $this->CreateOrder($date);                                //订单不存在时创建订单
            if($result) {
                $result = $this->PaymentProcessing($date);                      //启动支付处理流程
                return $result;
            } else {
                return FALSE;
            }
        } else {
            if(!$Order['status']) {
                $result = $this->PaymentProcessing($date);                      //启动支付处理流程
                return $result;
            } else {
                return FALSE;                                                   //判断已存在订单的支付状态，已完成支付的订单返回FALSE
            }
        }
    }
    /**
     * 支付处理
     */
    public function PaymentProcessing($date) {
        $this->UpadteOrderPaymentType($date['pay_type'], $date['out_trade_no']);//更新订单支付类型
        switch ($date['pay_type']) {
            case 1://微信扫码支付
                return $this->Payment_wxpay($date);
            case 2://财付通支付tenpay
                break;
            case 3://支付宝支付
                $this->Payment_alipay($date);
                break;
            case 4://网银支付
                $this->Payment_unionpay($date);
                break;
            case 5://PayPal支付
                break;
            case 6://微信H5-JsApiPay支付
                return $this->Payment_wxpay_H5($date);
            default:
                break;
        }
    }
    public function Payment_wxpay($date) {
		global $_M;
        $wxpay             = load::mod_class('pay/wxpay.class.php', 'new');     //加载微信支付处理类
        $array['code_url'] = "{$_M['url']['site']}app/system/web/pay/wxpay/qrcode.php?data=".$wxpay->wxpay($date);                              //调用微信支付接口
        return json_encode($array);                                             //返回二维码链接 json 形式返回
    }
    public function Payment_alipay($date) {
        $alipay = load::mod_class('pay/alipay.class.php', 'new');               //加载支付宝支付处理类
        $alipay->alipay($date);                                                 //调用支付宝支付接口
    }
    public function Payment_unionpay($date) {
        $unionpay = load::mod_class('pay/unionpay.class.php', 'new');           //加载银联支付处理类
        $unionpay->unionpay($date);                                             //调用银联支付接口
    }
    public function Payment_wxpay_H5($date) {
		global $_M;
        $wxpay = load::mod_class('pay/wxpay.class.php', 'new');                 //加载微信支付处理类
		$date['openId'] = $_M['form']['openId'];
		$result         = $wxpay->JsApiPay($date);                          //调用微信H5支付接口
		return json_encode($result);                                        //返回json数据 'Parameters','Address'
		
		/*
        if($_GET["code"]){
            //session_start();                                                    //获取session中存储的订单信息
            //$date           = $_SESSION["temp"];
            $date['openId'] = $wxpay->GetOpen_ID();
            $result         = $wxpay->JsApiPay($date);                          //调用微信H5支付接口
            return json_encode($result);                                        //返回json数据 'Parameters','Address'
        }else{
            //session_start();                                                    //session 存储订单信息，备用
            //$_SESSION["temp"] = $date;
            $wxpay->GetOpen_ID();
        }
		*/
    }
}
# This program is an open source system, commercial use, please consciously to purchase commercial license.
# Copyright (C) MetInfo Co., Ltd. (http://www.metinfo.cn). All rights reserved.
?>