<?php
defined('IN_MET') or exit('No permission');
load::sys_class('web');

class met_wechat extends web
{
    public function __construct()
    {
        global $_M;
        parent::__construct();
        load::own_class('LW');
        $this->LW_BASE  = load::own_class('LW_BASE', 'new');
        $this->LW_REPLY = load::own_class('LW_REPLY', 'new');
        $this->config   = LW::config('get', '', 'met_wechat', 'metinfo');
    }
    public function doent()
    {
        global $_M;
        switch ($_SERVER['REQUEST_METHOD']) {
            case 'POST':
                $postStr = file_get_contents("php://input");
                $this->LW_REPLY->reply($postStr);
                break;
            default:
                $this->LW_REPLY->checkSign();
                break;
        }
    }
    public function domsg_tmp()
    {
        global $_M;
        $action      = $_M['form']['action'];
        $signpackage = $this->signpackage();
        switch ($action) {
            case 'detail':
                $this->wx_user();
                $news = $this->LW_BASE->get_msg_detail($_M['form']['id']);
                if ($news) {
                    $page = array(
                        "title"       => $news['title'],
                        "description" => str_replace(array(PHP_EOL, "\r\n", "\r", "\n"), "", $news['description']),
                        "img"         => $news['img'],
                    );
                    $news['addtime'] = date("Y-m-d H:i", $news['addtime']);
                    $qrcodeurl       = $this->LW_BASE->self_url('', '', 'domsg_tmp') . "&action=qrcode";
                    require_once LW::template("detail");
                }
                break;
            case 'qrcode':
                $page = array(
                    "title"       => "微信扫码关注",
                    "description" => str_replace(array(PHP_EOL, "\r\n", "\r", "\n"), "", $_M['config']['met_description']),
                    "url"         => $this->LW_BASE->self_url('', '', 'domsg_tmp') . "&action=qrcode",
                    "img"         => $_M['url']['site'] . str_replace("../", "", $this->config['wechat_qrcode']),
                );
                require_once LW::template("qrcode");
                break;
            case 'jf':
                $openid = $this->LW_BASE->get_useropenid();
                $user   = $this->LW_BASE->get_wx_user($openid['openid']);
                $this->LW_BASE->is_subscribe($user);
                $page = array(
                    "title"       => "用户积分",
                    "description" => str_replace(array(PHP_EOL, "\r\n", "\r", "\n"), "", $_M['config']['met_description']),
                    "url"         => $this->LW_BASE->self_url('', '', 'domsg_tmp') . "&action=jf",
                    "img"         => $_M['url']['site'] . str_replace("../", "", $_M['config']['met_logo']),
                );
                $points           = $this->LW_BASE->user_points($openid['openid'], 'view');
                $list             = $this->LW_BASE->get_points_list($openid['openid'], $_M['form']['page'], '10');
                $user['nickname'] = urldecode($user['nickname']);
                $prev             = $list['page_prev'] ? '' : 'am-disabled';
                $next             = $list['page_next'] ? '' : 'am-disabled';
                $prevurl          = $list['page_prev'] ? $page['url'] . '&page=' . $list['page_prev'] : 'javascript:;';
                $nexturl          = $list['page_next'] ? $page['url'] . '&page=' . $list['page_next'] : 'javascript:;';
                require_once LW::template("jf");
                break;
            default:
                $this->wx_user();
                $page = array(
                    "title"       => "图文列表",
                    "description" => str_replace(array(PHP_EOL, "\r\n", "\r", "\n"), "", $_M['config']['met_description']),
                    "url"         => $this->LW_BASE->self_url('', '', 'domsg_tmp'),
                    "img"         => $_M['url']['site'] . str_replace("../", "", $_M['config']['met_logo']),
                );
                $list    = $this->LW_BASE->get_msg_list($_M['form']['page'], '10');
                $prev    = $list['page_prev'] ? '' : 'am-disabled';
                $next    = $list['page_next'] ? '' : 'am-disabled';
                $prevurl = $list['page_prev'] ? $page['url'] . '&page=' . $list['page_prev'] : 'javascript:;';
                $nexturl = $list['page_next'] ? $page['url'] . '&page=' . $list['page_next'] : 'javascript:;';
                require_once LW::template("index");
                break;
        }
    }
    public function doget_access_token()
    {
        global $_M;
        $token = $_M['form']['token'];
        if ($token) {
            if ($token == $this->config['wechat_token']) {
                $r['errcode']      = '0';
                $r['access_token'] = $this->LW_BASE->get_access_token();
            } else {
                $r['errcode'] = '403';
                $r['errmsg']  = 'TOKEN ERR!';
            }
        } else {
            $r['errcode'] = '403';
            $r['errmsg']  = 'NO TOKEN!';
        }
        echo json_encode($r);
    }
    public function doget_jsapiticket()
    {
        global $_M;
        $token = $_M['form']['token'];
        if ($token) {
            if ($token == $this->config['wechat_token']) {
                $r['errcode']     = '0';
                $r['jsapiticket'] = $this->LW_BASE->getjsapiticket();
            } else {
                $r['errcode'] = '403';
                $r['errmsg']  = 'TOKEN ERR!';
            }
        } else {
            $r['errcode'] = '403';
            $r['errmsg']  = 'NO TOKEN!';
        }
        echo json_encode($r);
    }
    private function wx_user()
    {
        global $_M;
        $user_agent = $_SERVER['HTTP_USER_AGENT'];
        if (strpos($user_agent, 'MicroMessenger') == true) {
            $openid = $this->LW_BASE->get_useropenid();
            $openid = $openid['openid'];
            $r      = $this->LW_BASE->get_userinfo_sub($openid);
        }
        return $r;
    }
    private function signpackage()
    {
        global $_M;
        $user_agent = $_SERVER['HTTP_USER_AGENT'];
        if (strpos($user_agent, 'MicroMessenger') == true) {
            return $this->LW_BASE->getSignPackage();
        }
    }
}
