<?php 

defined('IN_MET') or exit('No permission');

require_once PATH_ALL_APP.'met_qiniu/include/class/qiniuoss/autoload.php';
use Qiniu\Auth;
use Qiniu\Storage\BucketManager;

Class qiniuOSS {
	/**
	 * 存储空间名称
	 * @var string
	 */
	public $bucket;

	/**
	 * 鉴权
	 */
	public $auth;

	/**
	 * 存储空间管理对象
	 * @var object
	 */
	public $bucketMgr;


	public function __construct($access_key,$secret_key) {

		global $_M;
		$this->auth = new Auth($access_key, $secret_key);
		$this->bucketMgr = new BucketManager($this->auth);
		$this->bucket = $_M['config']['met_qiniu_bucket'];
	}
    
	/**
	 * 检测存储空间是否存在
	 * @DateTime 2017-05-11
	 * @return   boolean 
	 */
    public function hasBucket() {
    	global $_M;
    	$buckets = $this->listBuckets();
    	return in_array($this->bucket, $buckets[0]);
    }

    /**
     * 创建一个存储空间
     * @DateTime 2017-05-11
     * @return null
     */
    public function createBucket() {
    	global $_M;
    	return $this->bucketMgr->createBucket($this->bucket);
    }

        /**
     * 列出所有存储空间
     * @DateTime 2017-05-11
     * @return  array
     */
	public function listBuckets() {
		global $_M;
		
		$buckets = $this->bucketMgr->buckets();
		return $buckets;
	}
	
	/**
	 * 已绑定存储空间的域名列表
	 * @DateTime 2017-05-11
	 * @return   array
	 */
	public function getDomain() {

		return $this->bucketMgr->getDomain($this->bucket);
	}

	/**
	 * 绑定镜像域名
	 * @Author   long
	 * @DateTime 2017-06-02
	 * @param    string     $url 镜像链接
	 * @return   null
	 */
	public function create_image($url) {
		global $_M;
		list($ret, $err) = $this->bucketMgr->createImage($this->bucket, $url);
		return $err;
	}
}